#!/bin/sh
set -e

export DATADIR=/usr/share/tigase/database

read -sp "Enter mysql admin password: " MYSQLPSWD
echo
read -sp "Enter tigase_user password: " TIGASEPSWD
echo
read -p "Enter the server full hostname: " HOSTNAME

mysqladmin --password=$MYSQLPSWD create tigasedb
mysql --password=$MYSQLPSWD <<EOS
GRANT ALL ON tigasedb.* TO tigase_user
    IDENTIFIED BY '$TIGASEPSWD' ;
GRANT ALL ON tigasedb.* TO tigase_user@'localhost'
    IDENTIFIED BY '$TIGASEPSWD' ;
FLUSH PRIVILEGES;
EOS
mysql --password=$MYSQLPSWD tigasedb < $DATADIR/mysql-schema-4.sql

sed -i.backup -e 's/$HOST_NAME'"/$HOSTNAME/" \
	-e "s/@DBPASS@/$TIGASEPSWD/" /etc/tigase/init.properties
